Index: /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg
===================================================================
--- /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 426)
+++ /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 427)
@@ -151,5 +151,6 @@
 ALFPicBasedEncode              : 1                                 # ALF LCU-based or picture-based encoding (0: LCU-based, 1: Picture-based)  
 MaxNumOffsetsPerPic            : 2048                              # default
-SAOInterleaving                : 0                                 # SAO interleaving flag (0: SAO parameter in APS, 1: SAO parameter in slice data) 
+SAOLcuBoundary              : 0                                 # 0: right/bottom LCU boundary areas skipped from SAO parameter estimation, 1: non-deblocked pixels are used for those areas
+SAOLcuBasedOptimization : 1                                  # 0: SAO picture-based optimization, 1: SAO LCU-based optimization
 ConstrainedIntraPred           : 0                                 # Constrained Intra Prediction
 weighted_pred_flag             : 0                                 # weighted prediction flag (P-Slices)
@@ -199,4 +200,6 @@
 FCO                        : 0                                     # Flexible coding order flag in 3DV
 FCOCodingOrder             : T0D0D1T1                              # Coding order for Flexible coding order in 3DV
+UseVSPCompensation         : 1                                     # Depth dependent tools: BVSP
+UseDVPRefine               : 1                                     # Depth dependent tools: DoNBDV
 
 
Index: /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_2view.cfg
===================================================================
--- /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_2view.cfg	(revision 426)
+++ /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_2view.cfg	(revision 427)
@@ -145,5 +145,6 @@
 ALFPicBasedEncode              : 1                                 # ALF LCU-based or picture-based encoding (0: LCU-based, 1: Picture-based)  
 MaxNumOffsetsPerPic            : 2048                              # default
-SAOInterleaving                : 0                                 # SAO interleaving flag (0: SAO parameter in APS, 1: SAO parameter in slice data) 
+SAOLcuBoundary              : 0                                 # 0: right/bottom LCU boundary areas skipped from SAO parameter estimation, 1: non-deblocked pixels are used for those areas
+SAOLcuBasedOptimization : 1                                  # 0: SAO picture-based optimization, 1: SAO LCU-based optimization
 ConstrainedIntraPred           : 0                                 # Constrained Intra Prediction
 weighted_pred_flag             : 0                                 # weighted prediction flag (P-Slices)
Index: /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg
===================================================================
--- /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 426)
+++ /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 427)
@@ -155,5 +155,6 @@
 ALFPicBasedEncode              : 1                                 # ALF LCU-based or picture-based encoding (0: LCU-based, 1: Picture-based)  
 MaxNumOffsetsPerPic            : 2048                              # default
-SAOInterleaving                : 0                                 # SAO interleaving flag (0: SAO parameter in APS, 1: SAO parameter in slice data) 
+SAOLcuBoundary              : 0                                 # 0: right/bottom LCU boundary areas skipped from SAO parameter estimation, 1: non-deblocked pixels are used for those areas
+SAOLcuBasedOptimization : 1                                  # 0: SAO picture-based optimization, 1: SAO LCU-based optimization
 ConstrainedIntraPred           : 0                                 # Constrained Intra Prediction
 weighted_pred_flag             : 0                                 # weighted prediction flag (P-Slices)
@@ -203,5 +204,6 @@
 FCO                        : 0                                      # Flexible coding order flag in 3DV
 FCOCodingOrder             : T0D0D1D2T1T2                           # Coding order for Flexible coding order in 3DV
-
+UseVSPCompensation         : 1                                     # Depth dependent tools: BVSP
+UseDVPRefine               : 1                                     # Depth dependent tools: DoNBDV
 
 #========== depth coding tools ==========
Index: /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_3view.cfg
===================================================================
--- /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_3view.cfg	(revision 426)
+++ /branches/HTM-6.2-dev0/CommonTestConditionsCfgs/baseCfg_3view.cfg	(revision 427)
@@ -147,5 +147,6 @@
 ALFPicBasedEncode              : 1                                 # ALF LCU-based or picture-based encoding (0: LCU-based, 1: Picture-based)  
 MaxNumOffsetsPerPic            : 2048                              # default
-SAOInterleaving                : 0                                 # SAO interleaving flag (0: SAO parameter in APS, 1: SAO parameter in slice data) 
+SAOLcuBoundary              : 0                                 # 0: right/bottom LCU boundary areas skipped from SAO parameter estimation, 1: non-deblocked pixels are used for those areas
+SAOLcuBasedOptimization : 1                                  # 0: SAO picture-based optimization, 1: SAO LCU-based optimization 
 ConstrainedIntraPred           : 0                                 # Constrained Intra Prediction
 weighted_pred_flag             : 0                                 # weighted prediction flag (P-Slices)
Index: /branches/HTM-6.2-dev0/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 427)
@@ -389,4 +389,8 @@
 #endif
 #endif
+#if MTK_D0156
+  ("UseVSPCompensation", m_bUseVSPCompensation,   true, "Depth dependent tools: BVSP" )
+  ("UseDVPRefine", m_bUseDVPRefine,   true, "Depth dependent tools: DoNBDV" )
+#endif
 
   /* Coding tools */
@@ -396,5 +400,10 @@
   ("SAO", m_abUseSAO, std::vector<Bool>(1, true), "SAO")
   ("MaxNumOffsetsPerPic", m_maxNumOffsetsPerPic, 2048, "2048: default")   
+#if LGE_SAO_MIGRATION_D0091
+  ("SAOLcuBoundary",          m_saoLcuBoundary,          false, "0: right/bottom LCU boundary areas skipped from SAO parameter estimation, 1: non-deblocked pixels are used for those areas")
+  ("SAOLcuBasedOptimization", m_saoLcuBasedOptimization, true, "0: SAO picture-based optimization, 1: SAO LCU-based optimization ")
+#else
   ("SAOInterleaving", m_saoInterleavingFlag, false, "0: SAO Picture Mode, 1: SAO Interleaving ")   
+#endif
 
   ("ALFEncodePassReduction", m_iALFEncodePassReduction, 0, "0:Original 16-pass, 1: 1-pass, 2: 2-pass encoding")
@@ -1637,5 +1646,9 @@
   printf("CIP:%d ", m_bUseConstrainedIntraPred);
   printf("PCM:%d ", (m_usePCM && (1<<m_uiPCMLog2MinSize) <= m_uiMaxCUWidth)? 1 : 0);
+#if LGE_SAO_MIGRATION_D0091
+  printf("SAOLcuBasedOptimization:%d ", (m_saoLcuBasedOptimization)?(1):(0));
+#else
   printf("SAOInterleaving:%d ", (m_saoInterleavingFlag)?(1):(0));
+#endif
 #if LOSSLESS_CODING
   printf("LosslessCuEnabled:%d ", (m_useLossless)? 1:0 );
@@ -1723,4 +1736,10 @@
   printf("DLT:%d ", m_bUseDLT ? 1 : 0 );
 #endif
+
+#if MTK_D0156
+  printf("BVSP:%d ", m_bUseVSPCompensation ? 1 : 0 );
+  printf("DoNBDV:%d ",  m_bUseDVPRefine ? 1 : 0 );
+#endif
+
 #if LGE_WVSO_A0119
   if ( m_bUseWVSO )
Index: /branches/HTM-6.2-dev0/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- /branches/HTM-6.2-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 427)
@@ -165,5 +165,10 @@
 #endif
   Int       m_maxNumOffsetsPerPic;                            ///< SAO maximun number of offset per picture
+#if LGE_SAO_MIGRATION_D0091
+  Bool      m_saoLcuBoundary;                                 ///< SAO parameter estimation using non-deblocked pixels for LCU bottom and right boundary areas
+  Bool      m_saoLcuBasedOptimization;                        ///< SAO LCU-based optimization
+#else
   Bool      m_saoInterleavingFlag;                            ///< SAO interleaving flag
+#endif
   // coding tools (loop filter)
   vector<Bool> m_abUseALF;                                    ///< flag for using adaptive loop filter [0] - video, [1] - depth
@@ -321,4 +326,13 @@
 #endif
 
+#if MTK_D0156
+
+#if MERL_VSP_COMPENSATION_C0152
+  Bool      m_bUseVSPCompensation;
+#endif
+
+  Bool      m_bUseDVPRefine;
+#endif
+
   // internal member functions
   Void  xSetGlobal      ();                                   ///< set global variables
Index: /branches/HTM-6.2-dev0/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 427)
@@ -230,4 +230,10 @@
 #endif
 #endif
+#if MTK_D0156
+#if MERL_VSP_COMPENSATION_C0152
+    m_acTEncTopList[iViewIdx]->setUseVSPCompensation           ( iViewIdx ? m_bUseVSPCompensation : 0 );
+#endif
+    m_acTEncTopList[iViewIdx]->setUseDVPRefine                  ( iViewIdx ? m_bUseDVPRefine : 0 );
+#endif
 
   //====== Tool list ========
@@ -308,5 +314,10 @@
 #endif
     m_acTEncTopList[iViewIdx]->setMaxNumOffsetsPerPic (m_maxNumOffsetsPerPic);
+#if LGE_SAO_MIGRATION_D0091
+    m_acTEncTopList[iViewIdx]->setSaoLcuBoundary (m_saoLcuBoundary);
+    m_acTEncTopList[iViewIdx]->setSaoLcuBasedOptimization (m_saoLcuBasedOptimization);
+#else
     m_acTEncTopList[iViewIdx]->setSaoInterleavingFlag (m_saoInterleavingFlag);
+#endif
     m_acTEncTopList[iViewIdx]->setPCMInputBitDepthFlag  ( m_bPCMInputBitDepthFlag); 
     m_acTEncTopList[iViewIdx]->setPCMFilterDisableFlag  ( m_bPCMFilterDisableFlag); 
@@ -573,4 +584,12 @@
 #endif
 #endif
+#if MTK_D0156
+
+#if MERL_VSP_COMPENSATION_C0152
+      m_acTEncDepthTopList[iViewIdx]->setUseVSPCompensation           ( iViewIdx ? true : false );
+#endif
+
+      m_acTEncDepthTopList[iViewIdx]->setUseDVPRefine                 ( iViewIdx ? true : false );
+#endif
 
       //====== Weighted Prediction ========
@@ -615,5 +634,10 @@
 #endif
       m_acTEncDepthTopList[iViewIdx]->setMaxNumOffsetsPerPic (m_maxNumOffsetsPerPic);
+#if LGE_SAO_MIGRATION_D0091
+      m_acTEncDepthTopList[iViewIdx]->setSaoLcuBoundary (m_saoLcuBoundary);
+      m_acTEncDepthTopList[iViewIdx]->setSaoLcuBasedOptimization (m_saoLcuBasedOptimization);
+#else
       m_acTEncDepthTopList[iViewIdx]->setSaoInterleavingFlag (m_saoInterleavingFlag);
+#endif
       m_acTEncDepthTopList[iViewIdx]->setPCMInputBitDepthFlag  ( m_bPCMInputBitDepthFlag); 
       m_acTEncDepthTopList[iViewIdx]->setPCMFilterDisableFlag  ( m_bPCMFilterDisableFlag); 
Index: /branches/HTM-6.2-dev0/source/Lib/TLibCommon/ContextTables.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibCommon/ContextTables.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibCommon/ContextTables.h	(revision 427)
@@ -101,4 +101,8 @@
 #define NUM_ALF_SVLC_CTX              3       ///< number of context models for ALF SVLC (filter coeff.)
 
+#if LGE_SAO_MIGRATION_D0091
+#define NUM_SAO_MERGE_FLAG_CTX        1       ///< number of context models for SAO merge flags
+#define NUM_SAO_TYPE_IDX_CTX          1       ///< number of context models for SAO type index
+#else
 #define NUM_SAO_FLAG_CTX              1       ///< number of context models for SAO flag
 #define NUM_SAO_UVLC_CTX              2       ///< number of context models for SAO UVLC
@@ -108,4 +112,5 @@
 #define NUM_SAO_MERGE_UP_FLAG_CTX     1       ///< number of context models for AO SVLC (filter coeff.)
 #define NUM_SAO_TYPE_IDX_CTX          2       ///< number of context models for AO SVLC (filter coeff.)
+#endif
 #define CNU                          154      ///< dummy initialization value for unused context models 'Context model Not Used'
 
@@ -376,5 +381,21 @@
   { 141,  154,  159, }, 
 };
-
+#if LGE_SAO_MIGRATION_D0091
+static const UChar
+INIT_SAO_MERGE_FLAG[3][NUM_SAO_MERGE_FLAG_CTX] =
+{
+  { 153,  },
+  { 153,  },
+  { 153,  },
+};
+
+static const UChar 
+INIT_SAO_TYPE_IDX[3][NUM_SAO_TYPE_IDX_CTX] = 
+{
+  { 200, },
+  { 185, },
+  { 160, },
+};
+#else
 static const UChar 
 INIT_SAO_FLAG[3][NUM_SAO_FLAG_CTX] =  
@@ -424,4 +445,5 @@
   { 200,  140, }, 
 };
+#endif
 
 static const UChar 
Index: /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComDataCU.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComDataCU.cpp	(revision 427)
@@ -53,7 +53,14 @@
 #if MERL_VSP_C0152
 
+#if MTK_D0156
+#define CHECK_ADD_YET(pcCURef,uiIdx,vspIdx) && ( (!m_pcSlice->getSPS()->getUseVSPCompensation()) || (!( (pcCURef)->getVSPIndex(uiIdx) == vspIdx && bVspMvZeroDone[vspIdx-1] )))
+#else
 #define CHECK_ADD_YET(pcCURef,uiIdx,vspIdx) && !( (pcCURef)->getVSPIndex(uiIdx) == vspIdx && bVspMvZeroDone[vspIdx-1] )
+#endif
 
 inline Void TComDataCU::xInheritVspMode( TComDataCU* pcCURef, UInt uiIdx, Bool* bVspMvZeroDone, Int iCount, Int* iVSPIndexTrue, TComMvField* pcMvFieldNeighbours, DisInfo* pDInfo
+#if QC_BVSP_CleanUP_D0191
+  , UChar *puhInterDirNeighbours
+#endif
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
     , Int*     iVSPDirTrue
@@ -61,4 +68,11 @@
     )
 {
+#if MTK_D0156
+    if( !m_pcSlice->getSPS()->getUseVSPCompensation() )
+    {
+        return;
+    }
+#endif
+
   Int vspIdx = (Int) pcCURef->getVSPIndex(uiIdx);
   if( vspIdx != 0 )
@@ -73,4 +87,7 @@
     if (vspIdx < 4)
     {
+#if QC_BVSP_CleanUP_D0191
+      puhInterDirNeighbours[ iCount] = 1;
+#endif
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
       if(pDInfo->iN > 0 )
@@ -126,11 +143,30 @@
 }
 
-inline Bool TComDataCU::xAddVspMergeCand( UChar ucVspMergePos, Int vspIdx, Bool* bVspMvZeroDone, UInt uiDepth, Bool* abCandIsInter, Int& iCount,
-                                          UChar* puhInterDirNeighbours, TComMvField* pcMvFieldNeighbours, Int* iVSPIndexTrue, Int mrgCandIdx, DisInfo* pDInfo
+inline Bool TComDataCU::xAddVspMergeCand(
+ UChar ucVspMergePos,
+#if !LGE_VSP_INHERIT_D0092
+ Int vspIdx,
+ Bool* bVspMvZeroDone,
+#endif
+ UInt uiDepth,
+ Bool* abCandIsInter,
+ Int& iCount,
+ UChar* puhInterDirNeighbours,
+ TComMvField* pcMvFieldNeighbours,
+ Int* iVSPIndexTrue,
+ Int mrgCandIdx,
+ DisInfo* pDInfo
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
-                                        , Int*  iVspDirTrue
+ , Int*  iVspDirTrue
 #endif
                                           )
 {
+#if MTK_D0156
+    if( !m_pcSlice->getSPS()->getUseVSPCompensation() )
+    {
+        return true;
+    }
+#endif
+
 #if MTK_LGE_VSP_DEPTH_OFF_D0105_D0139
   if (getSlice()->getSPS()->isDepth())
@@ -149,11 +185,19 @@
   if( ucVspMergePos == VSP_MERGE_POS )
   {
+#if !LGE_VSP_INHERIT_D0092
     Int idx = vspIdx - 1;
-    {
+#endif
+    {
+#if LGE_VSP_INHERIT_D0092
+      if( getSlice()->getSPS()->getViewId() != 0 )
+#else
       if( getSlice()->getSPS()->getViewId() != 0 && bVspMvZeroDone[idx] == false )
+#endif
       {
         {
           abCandIsInter [iCount] = true;
+#if !LGE_VSP_INHERIT_D0092
           bVspMvZeroDone[idx] = true;
+#endif
 
           // get Inter Dir
@@ -161,4 +205,19 @@
             (getSlice()->getNumRefIdx(REF_PIC_LIST_0) > 0 ? 1 : 2));
           puhInterDirNeighbours[iCount] = iInterDir; // The direction information does not matter
+#if QC_BVSP_CleanUP_D0191
+         puhInterDirNeighbours[iCount] = 1;
+#endif
+#if LGE_VSP_INHERIT_D0092
+         Int iRefIdx = NOT_VALID;
+#if QC_BVSP_CleanUP_D0191
+         iRefIdx = getSlice()->getRefPic(REF_PIC_LIST_0, 0)->getPOC()==getSlice()->getPOC() ? 0: getSlice()->getNewRefIdx(REF_PIC_LIST_0);
+#endif
+         pcMvFieldNeighbours[iCount<<1].setMvField(pDInfo->m_acMvCand[0], iRefIdx );
+         if ( getSlice()->isInterB() )
+         {
+             pcMvFieldNeighbours[(iCount<<1)+1].setMvField( pDInfo->m_acMvCand[0], iRefIdx );
+         }
+         iVSPIndexTrue[iCount] = 1;
+#else
           // get Mv using checked disparity vector
           if (vspIdx < 4) // spatial
@@ -200,4 +259,5 @@
           }
           iVSPIndexTrue[idx] = iCount;
+#endif
           if ( mrgCandIdx == iCount )
           {
@@ -3239,6 +3299,25 @@
   UInt iNumbPart;
 
+#if SHARP_ILLUCOMP_PARSE_D0060
+  if (!(getPartitionSize(uiAbsPartIdx) == SIZE_2Nx2N))
+  {
+    return false;
+  }
+  if (getSlice()->getIcSkipParseFlag())
+  {
+    if (getMergeFlag(uiAbsPartIdx) && getMergeIndex(uiAbsPartIdx) == 0)
+    {
+      return false;
+    }
+  }
+  if (getMergeFlag(uiAbsPartIdx))
+  {
+    return true;
+  }
+#endif
+#if !SHARP_ILLUCOMP_PARSE_D0060
   if(!getSlice()->getIsDepth())
   {
+#endif
     Int iWidth, iHeight;
 
@@ -3261,4 +3340,5 @@
       }
     }
+#if !SHARP_ILLUCOMP_PARSE_D0060
   }
   else
@@ -3282,4 +3362,5 @@
     }
   }
+#endif
 
   return false;
@@ -3292,4 +3373,21 @@
   Int iWidth, iHeight;
 
+#if SHARP_ILLUCOMP_PARSE_D0060
+  if (!(getPartitionSize(uiAbsPartIdx) == SIZE_2Nx2N))
+  {
+    return false;
+  }
+  if (getSlice()->getIcSkipParseFlag())
+  {
+    if (getMergeFlag(uiAbsPartIdx) && getMergeIndex(uiAbsPartIdx) == 0)
+    {
+      return false;
+    }
+  }
+  if (getMergeFlag(uiAbsPartIdx))
+  {
+    return true;
+  }
+#endif
   UInt uiPartMode = getPartitionSize(uiAbsPartIdx);
 
@@ -3810,5 +3908,5 @@
   this->getPartPosition(uiPUIdx, xP, yP, nPSW, nPSH);
 
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 && !LGE_VSP_INHERIT_D0092
   Bool bVspMvZeroDone[3] = {false, false, false};
 #endif
@@ -3996,5 +4094,5 @@
         }
       }
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152  && !QC_BVSP_CleanUP_D0191 && !LGE_VSP_INHERIT_D0092
 #if !MTK_LGE_VSP_DEPTH_OFF_D0105_D0139
       xInheritVspMode( pcTextureCU, uiPartIdxCenter, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo
@@ -4077,4 +4175,5 @@
 #endif //  H3D_IVMP
 
+#if !FIX_MERGE_D
 #if MERL_VSP_COMPENSATION_C0152
   //===== vsp 0 ===== 
@@ -4088,4 +4187,5 @@
       return;
 #endif
+#endif
 
   //left
@@ -4104,5 +4204,5 @@
   {
     if ( pcCULeft && !pcCULeft->isIntra( uiLeftPartIdx )
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 && !LGE_VSP_INHERIT_D0092
       CHECK_ADD_YET(pcCULeft, uiLeftPartIdx, 1)
 #endif
@@ -4153,9 +4253,19 @@
 #endif
 #if MERL_VSP_C0152
+#if LGE_VSP_INHERIT_D0092
+        if (pcCULeft->getVSPIndex(uiLeftPartIdx)==1)
+        {
+            iVSPIndexTrue[iCount] = 1;
+        }
+#else
         xInheritVspMode( pcCULeft, uiLeftPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo
+#if QC_BVSP_CleanUP_D0191
+        ,puhInterDirNeighbours
+#endif
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
          , iVSPDirTrue
 #endif
                 );
+#endif
 #endif
         if ( mrgCandIdx == iCount )
@@ -4182,5 +4292,5 @@
     }
   if ( pcCUAbove && !pcCUAbove->isIntra( uiAbovePartIdx ) 
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 && !LGE_VSP_INHERIT_D0092
     CHECK_ADD_YET(pcCUAbove, uiAbovePartIdx, 1)
 #endif
@@ -4230,9 +4340,19 @@
 #endif
 #if MERL_VSP_C0152
+#if LGE_VSP_INHERIT_D0092
+    if (pcCUAbove->getVSPIndex(uiAbovePartIdx)==1)
+    {
+        iVSPIndexTrue[iCount] = 1;
+    }
+#else
      xInheritVspMode( pcCUAbove, uiAbovePartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo
+#if QC_BVSP_CleanUP_D0191
+        ,puhInterDirNeighbours
+#endif
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
        , iVSPDirTrue
 #endif
              ) ;
+#endif
 #endif
     if ( mrgCandIdx == iCount )
@@ -4258,5 +4378,5 @@
   }
   if ( pcCUAboveRight && !pcCUAboveRight->isIntra( uiAboveRightPartIdx ) 
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 && !LGE_VSP_INHERIT_D0092
     CHECK_ADD_YET(pcCUAboveRight, uiAboveRightPartIdx, 1)
 #endif
@@ -4283,9 +4403,19 @@
 #endif
 #if MERL_VSP_C0152
+#if LGE_VSP_INHERIT_D0092
+    if (pcCUAboveRight->getVSPIndex(uiAboveRightPartIdx)==1)
+    {
+        iVSPIndexTrue[iCount] = 1;
+    }
+#else
     xInheritVspMode( pcCUAboveRight, uiAboveRightPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo
+#if QC_BVSP_CleanUP_D0191
+        ,puhInterDirNeighbours
+#endif 
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
        , iVSPDirTrue
 #endif
             ) ;
+#endif
 #endif
     if ( mrgCandIdx == iCount )
@@ -4345,4 +4475,26 @@
 #endif // H3D_IVMP 
 
+#if MERL_VSP_COMPENSATION_C0152
+  //===== vsp 3 =====
+#if LGE_VSP_INHERIT_D0092
+    if ( !xAddVspMergeCand(3, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
+#else
+    if( iCount < 4 + extraMergeCand )
+        if ( !xAddVspMergeCand(3, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
+#endif
+            return;
+#endif
+
+#if MERL_VSP_C0152
+#if VSP_MERGE_POS < 4
+#if H3D_IVMP
+    if( iCount < 4 + extraMergeCand )
+#else
+    if( iCount < 4 )
+#endif
+    {
+#endif
+#endif
+
   //left bottom
   UInt uiLeftBottomPartIdx = 0;
@@ -4357,5 +4509,5 @@
   }
   if ( pcCULeftBottom && !pcCULeftBottom->isIntra( uiLeftBottomPartIdx ) 
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 && !LGE_VSP_INHERIT_D0092
     CHECK_ADD_YET(pcCULeftBottom, uiLeftBottomPartIdx, 1)
 #endif
@@ -4382,5 +4534,14 @@
 #endif
 #if MERL_VSP_C0152
+#if LGE_VSP_INHERIT_D0092
+    if (pcCULeftBottom->getVSPIndex(uiLeftBottomPartIdx)==1)
+    {
+        iVSPIndexTrue[iCount] = 1;
+    }
+#else
     xInheritVspMode( pcCULeftBottom, uiLeftBottomPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo
+#if QC_BVSP_CleanUP_D0191
+        ,puhInterDirNeighbours
+#endif
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
        , iVSPDirTrue
@@ -4388,4 +4549,5 @@
              ) ;
 #endif
+#endif
     if ( mrgCandIdx == iCount )
     {
@@ -4394,4 +4556,10 @@
     iCount ++;
   }
+
+#if MERL_VSP_C0152  // Is this correct here?
+#if VSP_MERGE_POS < 4
+    }
+#endif
+#endif
 
   // above left
@@ -4413,5 +4581,5 @@
     }
     if( pcCUAboveLeft && !pcCUAboveLeft->isIntra( uiAboveLeftPartIdx )
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 && !LGE_VSP_INHERIT_D0092
      CHECK_ADD_YET(pcCUAboveLeft, uiAboveLeftPartIdx, 1)
 #endif
@@ -4440,9 +4608,19 @@
 #endif
 #if MERL_VSP_C0152
+#if LGE_VSP_INHERIT_D0092
+    if (pcCUAboveLeft->getVSPIndex(uiAboveLeftPartIdx)==1)
+    {
+        iVSPIndexTrue[iCount] = 1;
+    }
+#else
       xInheritVspMode( pcCUAboveLeft, uiAboveLeftPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo
+#if QC_BVSP_CleanUP_D0191
+        ,puhInterDirNeighbours
+#endif 
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
        , iVSPDirTrue
 #endif
              ) ;
+#endif
 #endif
       if ( mrgCandIdx == iCount )
@@ -4457,9 +4635,17 @@
   //===== vsp 5 =====
   if( iCount < 4 + extraMergeCand )
+#if LGE_VSP_INHERIT_D0092
+    if ( !xAddVspMergeCand(5, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) 
+#if MERL_VSP_NBDV_RefVId_Fix_D0166
+         , iVSPDirTrue
+#endif
+)
+#else
     if ( !xAddVspMergeCand(5, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
          , iVSPDirTrue
 #endif
-            ) )
+            ) 
+#endif
       return;
 #endif
@@ -4651,7 +4837,19 @@
 #if MERL_VSP_C0152
       Bool bValid = true;
+#if LGE_VSP_INHERIT_D0092
+      if (iVSPIndexTrue[i]==1 || iVSPIndexTrue[j]==1) // NOT_VALID
+#else
       if (pcMvFieldNeighbours[i<<1].getRefIdx() < 0 || pcMvFieldNeighbours[(j<<1)+1].getRefIdx() < 0) // NOT_VALID
+#endif
         bValid = false;
 #endif
+
+#if MTK_D0156
+      if( !m_pcSlice->getSPS()->getUseVSPCompensation())
+      {
+          bValid = true;
+      }
+#endif
+
       if (abCandIsInter[i] && abCandIsInter[j]&& (puhInterDirNeighbours[i]&0x1)&&(puhInterDirNeighbours[j]&0x2)
 #if MERL_VSP_C0152
@@ -4822,5 +5020,5 @@
   {
     if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) 
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
      && !pcCorner->getVSPIndex( uiCornerPUIdx )
 #endif
@@ -4968,5 +5166,5 @@
     pcTmpCU = getPULeft(uiIdx, uiPartIdxLB, true, false);
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
   if(! pcTmpCU->getVSPIndex(uiIdx))
 #endif
@@ -4993,5 +5191,5 @@
 
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
   if(! pcTmpCU->getVSPIndex(uiIdx))
 #endif
@@ -5018,5 +5216,5 @@
       pcTmpCU = getPUAboveRight(uiIdx, uiPartIdxRT, true, false, true);
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
   if(! pcTmpCU->getVSPIndex(uiIdx))
 #endif
@@ -5042,5 +5240,5 @@
       pcTmpCU = getPUBelowLeft(uiIdx, uiPartIdxLB, true, false);
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
   if(! pcTmpCU->getVSPIndex(uiIdx))
 #endif
@@ -5069,5 +5267,5 @@
     assert(uiPartIdxLT == (m_uiAbsIdxInLCU + uiPartAddr));
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
   if(! pcTmpCU->getVSPIndex(uiIdx))
 #endif
@@ -5277,17 +5475,30 @@
   Int iPictureWidth  = pcBaseViewDepthPicYuv->getWidth();
   Int iPictureHeight = pcBaseViewDepthPicYuv->getHeight();
-
+#if !QC_BVSP_CleanUP_D0191
+#if LGE_ROUND_OFFSET_D0135
+  Int depthPosX = Clip3(0,   iPictureWidth - iBlkWidth,  iBlkX + ((mv->getHor()+2)>>2));
+  Int depthPosY = Clip3(0,   iPictureHeight- iBlkHeight,  iBlkY + ((mv->getVer()+2)>>2));
+#else
   Int depthPosX = Clip3(0,   iPictureWidth - iBlkWidth,  iBlkX + (mv->getHor()>>2));
   Int depthPosY = Clip3(0,   iPictureHeight- iBlkHeight,  iBlkY + (mv->getVer()>>2));
+#endif
 
   Pel *pDepthPel   = pcBaseViewDepthPicYuv->getLumaAddr() + depthPosX + depthPosY * depStride;
+#endif
   Pel  maxDepthVal = 0;
 
   if ( bSimpleDvpRefine )
   {
+#if LGE_ROUND_OFFSET_D0135
+    Int depthStartPosX = Clip3(0,   iPictureWidth - iBlkWidth,  iBlkX + ((mv->getHor()+2)>>2));
+    Int depthStartPosY = Clip3(0,   iPictureHeight- iBlkHeight,  iBlkY + ((mv->getVer()+2)>>2));
+    Int depthEndPosX   = Clip3(0,   iPictureWidth - 1,  iBlkX + iBlkWidth - 1 + ((mv->getHor()+2)>>2));
+    Int depthEndPosY   = Clip3(0,   iPictureHeight - 1,  iBlkY + iBlkHeight - 1 + ((mv->getVer()+2)>>2));
+#else
     Int depthStartPosX = Clip3(0,   iPictureWidth - iBlkWidth,  iBlkX + (mv->getHor()>>2));
     Int depthStartPosY = Clip3(0,   iPictureHeight- iBlkHeight,  iBlkY + (mv->getVer()>>2));
     Int depthEndPosX   = Clip3(0,   iPictureWidth - 1,  iBlkX + iBlkWidth - 1 + (mv->getHor()>>2));
     Int depthEndPosY   = Clip3(0,   iPictureHeight - 1,  iBlkY + iBlkHeight - 1 + (mv->getVer()>>2));
+#endif
 #if !MTK_DEPTH_TO_DISP_D0138
     Int iCenterX = (depthStartPosX + depthEndPosX) >> 1;
@@ -5312,4 +5523,5 @@
     }
   }
+#if !QC_BVSP_CleanUP_D0191
   else
   {
@@ -5324,4 +5536,5 @@
     }
   }
+#endif
 
   Int iDisp = aiShiftLUT[ maxDepthVal ] << iShiftPrec;
@@ -5425,5 +5638,5 @@
         }
       }
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
       else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
       { 
@@ -5576,4 +5789,11 @@
   }
 
+#if MTK_D0156
+  if( !m_pcSlice->getSPS()->getUseDVPRefine() )
+  {
+      bDepthRefine = false;
+  }
+#endif
+
   // Get Positions  
   PartSize eCUMode    = getPartitionSize( uiPartAddr );    
@@ -5927,6 +6147,13 @@
  */
 #if H3D_IVMP
+#if SEC_TWO_CANDIDATES_FOR_AMVP_D0122
 Void TComDataCU::fillMvpCand ( UInt uiPartIdx, UInt uiPartAddr, RefPicList eRefPicList, Int iRefIdx, AMVPInfo* pInfo, Int iMVPIdx)
 {
+    fillMvpCandBase(uiPartIdx, uiPartAddr, eRefPicList, iRefIdx, pInfo);
+}
+#else
+Void TComDataCU::fillMvpCand ( UInt uiPartIdx, UInt uiPartAddr, RefPicList eRefPicList, Int iRefIdx, AMVPInfo* pInfo, Int iMVPIdx)
+{
+
   if (!m_pcSlice->getSPS()->getViewId() || !m_pcSlice->getSPS()->getMultiviewMvPredMode())
   {
@@ -6014,4 +6241,5 @@
   }
 }
+#endif
 
 
@@ -6312,5 +6540,5 @@
   }
  
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152&!QC_BVSP_CleanUP_D0191
   if(pcTmpCU != NULL && pcTmpCU->getVSPIndex(uiIdx))
   {
@@ -6428,5 +6656,5 @@
   }
 
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 &!QC_BVSP_CleanUP_D0191
   if(pcTmpCU->getVSPIndex(uiIdx))
   {
@@ -6591,5 +6819,5 @@
   TComDataCU *pColCU = pColPic->getCU( uiCUAddr );
   iColViewIdx = pColCU->getSlice()->getViewId();
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
   if( pColCU->getCUMvField(eColRefPicList)->getRefIdx(uiAbsPartAddr) < 0)
   {
Index: /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComDataCU.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComDataCU.h	(revision 427)
@@ -282,11 +282,26 @@
   Bool          xAddMVPCandOrder      ( AMVPInfo* pInfo, RefPicList eRefPicList, Int iRefIdx, UInt uiPartUnitIdx, MVP_DIR eDir );
 #if MERL_VSP_C0152
-  inline Bool   xAddVspMergeCand      ( UChar ucVspMergePos, Int vspIdx, Bool* bVspMvZeroDone, UInt uiDepth, Bool* abCandIsInter, Int& iCount,
-                                        UChar* puhInterDirNeighbours, TComMvField* pcMvFieldNeighbours, Int* iVSPIndexTrue, Int mrgCandIdx, DisInfo* pDisInfo
+  inline Bool   xAddVspMergeCand      ( 
+ UChar ucVspMergePos,
+#if !LGE_VSP_INHERIT_D0092
+ Int vspIdx,
+ Bool* bVspMvZeroDone,
+#endif
+ UInt uiDepth,
+ Bool* abCandIsInter,
+ Int& iCount,
+ UChar* puhInterDirNeighbours,
+ TComMvField* pcMvFieldNeighbours,
+ Int* iVSPIndexTrue,
+ Int mrgCandIdx,
+ DisInfo* pDisInfo
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
-                                      , Int*   iVspDirTrue = NULL
+ , Int*   iVspDirTrue = NULL
 #endif
                                         );
   inline Void   xInheritVspMode       ( TComDataCU* pcCURef, UInt uiIdx, Bool* bVspMvZeroDone, Int iCount, Int* iVSPIndexTrue, TComMvField* pcMvFieldNeighbours, DisInfo* pDInfo
+#if QC_BVSP_CleanUP_D0191
+   ,UChar *puhInterDirNeighbours
+#endif
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
                                       , Int *iVSPDirTrue
Index: /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComLoopFilter.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 427)
@@ -428,5 +428,5 @@
   //-- Set BS for Intra MB : BS = 4 or 3
   if ( pcCUP->isIntra(uiPartP) || pcCUQ->isIntra(uiPartQ) 
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
     || pcCUP->getVSPIndex(uiPartP) || pcCUQ->getVSPIndex(uiPartQ)
 #endif
@@ -438,5 +438,5 @@
   //-- Set BS for not Intra MB : BS = 2 or 1 or 0
   if ( !pcCUP->isIntra(uiPartP) && !pcCUQ->isIntra(uiPartQ) 
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
     && !pcCUP->getVSPIndex(uiPartP) && !pcCUQ->getVSPIndex(uiPartQ)
 #endif
@@ -534,5 +534,5 @@
   }   // enf of "if( not Intra )"
   
-#if MERL_VSP_C0152
+#if MERL_VSP_C0152 & !QC_BVSP_CleanUP_D0191
   if ( pcCUP->getVSPIndex(uiPartP) || pcCUQ->getVSPIndex(uiPartQ))
   {
